#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>

#include "misc.h"

char tabASC[256];
char tabCOMPLETO[256];

//------------------------------------------------------------------------------
// Prepara tabela ASCII (tabASC)
void tabASCinic(void)
{
    char * especialASCII[] = { "aeiou", "", "", "",
                        "", "", "" };
    char outrosASCII[] = "#$&'-0123456789@~";
    int  caract;
    char ch,*cpont;
    memset(tabASC, 0, 256);   // Limpa todos os caracteres
    for (caract='a'; caract<='z'; caract++)
        tabASC[caract-0x20]=tabASC[caract]=caract;  // Letras de A a Z
    for (caract=0; especialASCII[0][caract]; caract++)  // Caracteres especiais
        for (cpont=especialASCII[caract+1]; *cpont; cpont++)
        {
            ch=especialASCII[0][caract];
            tabASC[*(unsigned char *)cpont]=ch;
        }
    for (cpont=outrosASCII; *cpont; cpont++)
        tabASC[*(unsigned char *)cpont]=*cpont;
    for (caract=0; caract<256; caract++)
        tabCOMPLETO[caract] = (tabASC[caract] ? tabASC[caract] : caract);
}

//------------------------------------------------------------------------------
// Semelhante a sprintf(), exceto que:
// S processa caracteres %%, %c, %d e %s
// %t = mensagem de tamanho TAM_NOME (nome de sala ou usurio)
// tamanho  o tamanho mximo do buffer destino
char * mprintf(char * destino, int tamanho, const char * mens, ...)
{
    const char * fim=&destino[tamanho<=0 ? 0 : tamanho-1];
    const char * p;
    char * p2;
    char numero[20];
    bool zerofinal=(tamanho>0);
    va_list argp;
    va_start(argp, mens);
    for (; *mens; mens++)
    {
        if (*mens!='%')
        {
            if (destino<fim)
                *(destino++)=*mens;
            continue;
        }
        mens++;
        switch (*mens)
        {
        case '%':
            if (destino<fim)
                *(destino++)='%';
            break;
        case 'c':
            if (destino<fim)
                *(destino++)=va_arg(argp, int);
            break;
        case 's':
            for (p=va_arg(argp, char *); *p && destino<fim; p++,destino++)
                *destino=*p;
            break;
        case 'd':
            tamanho=va_arg(argp, int);
            if (destino>=fim)
                break;
            if (tamanho<0)
            {
                *destino++='-';
                tamanho=-tamanho;
            }
            for (p2=numero; p2<&numero[sizeof(numero)] && tamanho; tamanho/=10)
                *p2++=tamanho%10+'0';
            if (p2==numero)
                *p2++='0';
            for (p=p2-1; p>=numero && destino<fim; p--)
                *destino++=*p;
            break;
        case 't':
            p=va_arg(argp, char *);
            for (tamanho=0; tamanho<TAM_NOME && destino<fim; tamanho++)
            {
                if (*p==0 || *p==' ')
                    break;
                *destino++=*p++;
            }
            break;
        default:
            mens--;
        }
    }
    if (zerofinal)
        *destino=0;
    va_end(argp);
    return destino;
}

//------------------------------------------------------------------------------
// Semelhante a strcpy(), mas retorna endereo do byte =0 em destino
char * copiastr(char * destino, const char * origem)
{
    while (*origem)
        *(destino++) = *(origem++);
    *destino=0;
    return destino;
}

//------------------------------------------------------------------------------
// Semelhante a strcpy(), mas retorna endereo do byte =0 em destino
// tamanho = nmero de caracteres que pode escrever em destino
char * copiastr(char * destino, const char * origem, int tamanho)
{
    tamanho--;
    if (tamanho<0)
        return destino;
    for (; tamanho; tamanho--)
        if (*origem==0)
            break;
        else
            *(destino++) = *(origem++);
    *destino=0;
    return destino;
}

//------------------------------------------------------------------------------
// Compara duas strings terminadas em espao ou 0
// Retorna: 0=strings iguais  -1=string1<string2  1=string1>string2
int compara(const char * string1, const char * string2)
{
    unsigned char ch1,ch2;
    while (true)
    {
        ch1=tabASC[*(unsigned char *)string1];
        ch2=tabASC[*(unsigned char *)string2];
        if (ch1==0) ch1=*string1;
        if (ch2==0) ch2=*string2;
        if (ch1==' ') ch1=0;
        if (ch2==' ') ch2=0;
        if (ch1==0 || ch1!=ch2)
            break;
        string1++;
        string2++;
    }
    return (ch1==ch2 ? 0 : ch1<ch2 ? -1 : 1);
}

//------------------------------------------------------------------------------
// Compara duas strings ASCIIZ
// Retorna: 0=strings iguais  -1=string1<string2  1=string1>string2
int comparaZ(const char * string1, const char * string2)
{
    unsigned char ch1,ch2;
    while (true)
    {
        if (*string1==' ' && *string2==' ')
        {
            for (; *string1==' '; string1++);
            for (; *string2==' '; string2++);
        }
        if (*string1==0 || *string2==0)
        {
            for (; *string1==' '; string1++);
            for (; *string2==' '; string2++);
        }
        ch1=tabCOMPLETO[*(unsigned char *)string1];
        ch2=tabCOMPLETO[*(unsigned char *)string2];
        if (ch1==0 || ch1!=ch2)
            break;
        string1++;
        string2++;
    }
    return (ch1==ch2 ? 0 : ch1<ch2 ? -1 : 1);
}

//------------------------------------------------------------------------------
// Verifica se nome vlido, mas no verifica se  um comando do chat
// Entrada: nome em ASCIIZ (termina com 0 ou ' ')
// Retorna: 0=nome invlido para sala e usurio
//          1=nome vlido s para sala
//          2=nome vlido para sala e usurio
char verifNome(const char * nome1)
{
    char tamanho,ch;
    char anterior=0;
    bool apel=false;
    char verifH=0;      // Para no permitir letra antes de h, exceto
                        // em ch, lh, nh, quando apelido tiver vogal
    for (tamanho=0; nome1[tamanho]; tamanho++)
        if (nome1[tamanho]==' ')
            return 0;
    for (tamanho=0; tamanho<=TAM_NOME; tamanho++)
    {
        if (*nome1==0 || *nome1==' ')
            break;
        ch=tabASC[*(unsigned char *)nome1];
        if (ch==0)
            return 0;
        if (ch=='h' && anterior>='a' && anterior<='z' &&
                  anterior!='c' && anterior!='l' && anterior!='n' &&
                  anterior!='a' && anterior!='e' && anterior!='i' &&
                  anterior!='o' && anterior!='u' && anterior!='y' &&
                  anterior!='w' && anterior!='p')
            if ( (verifH|=1) ==3 )
                return 0;
        if (ch>='a' && ch<='z' || ch=='')
        {
            apel=true;
            if (ch=='a' || ch=='e' || ch=='i' || ch=='o' || ch=='u')
                if ( (verifH|=2) ==3 )
                    return 0;
        }
        else
            verifH=0;
        anterior=ch;
        nome1++;
    }
    if (tamanho<2 || tamanho>TAM_NOME)
        return 0;
    return (apel ? 2 : 1);
}

//------------------------------------------------------------------------------
// Prepara mensagem para ser enviada para Telnet
// Retorna tamanho da mensagem (quandos bytes enviar via cEnvia())
int PreparaTelnet(char * destino, const char * origem, int tamdestino)
{
    int total=2;
    if (tamdestino<=3)
        return 0;
    for (; *origem; origem++)
        if (*origem=='\n')
        {
            if (total+2>tamdestino)
                break;
            *(destino++)=0x0D;
            *(destino++)=0x0A;
            total+=2;
        }
        else
        {
            if (total+1>tamdestino)
                break;
            *(destino++)=*origem;
            total++;
        }
    destino[0]=0x0D;
    destino[1]=0x0A;
    return total;
}

//------------------------------------------------------------------------------
// Prepara mensagem para ser enviada para Papovox
// tamlinha = quantos caracteres por linha o Papovox suporta, geralmente 80 ou 256
// Retorna tamanho da mensagem (quandos bytes enviar via cEnvia())
int PreparaPapovox(char * destino, const char * origem, int tamdestino, int tamlinha)
{
    int tam,tam2;   // Para descobrir quantos caracteres copiar
    char dest=0;    // Para acrescentar "/ " na continuao da mensagem
    int total=0;    // Parmetro de retorno
    tamlinha--;
    if (tamdestino<10)
        return 0;
    while (*origem && tamdestino>6)
    {
    // Obtm: tam2=nmero de caracteres que deve copiar
        for (tam=0,tam2=0;
             origem[tam] && origem[tam]!='\n' && tam<tamlinha-dest;
             tam++)
            if (origem[tam]==' ')
                tam2=tam;
        if (origem[tam]==0 || origem[tam]=='\n' || tam2<tamlinha-16)
            tam2=tam;
    // Acerta o nmero de caracteres conforme tamdestino
        if (tam2>tamdestino-dest-3)
            tam2=tamdestino-dest-3;
    // Anota cabealho
        destino[total]=1;
        destino[total+1]=(tam2+dest)&0xFF;
        destino[total+2]=(tam2+dest)>>8;
    // Copia mensagem
        destino[total+3]=' ';
        destino[total+4]='/';
        memcpy(destino+total+dest+3, origem, tam2);
    // Anota quantos bytes faltam
        origem+=tam2;
        tamdestino-=tam2+dest+3;
        total+=tam2+dest+3;
        dest=2;
    // Verifica prxima linha
        if (*origem=='\n')
        {
            origem++;
            dest=0;
        }
    }
    return total;
}
